﻿var docObj = documents.add(DocumentColorSpace.CMYK,595.28,500.95);//新規ドキュメント作成
app.coordinateSystem=CoordinateSystem.ARTBOARDCOORDINATESYSTEM;　//座標値をアートボード基準
var CRCODE = String.fromCharCode(13);//改行
var actDoc = activeDocument;//アクティブドキュメント指定

var enemy = Math.floor (Math.random() * 200) + 50;//モンスターのHP

var myName = 'ロト';
var myLife = 100; //自分のHP
var yellow = myLife * 0.5;//イエローライン表示用
var red = myLife * 0.25;//レッドーライン表示用

var win = new Window ('dialog', 'モンスターが現れた', [500,500,710,600]);//ウインドウパネル のモンスターが現れた!
win.add ("statictext", [40,20,180,30],  '戦いますか?');//このモンスターと戦いますか?
var btnOK = win.add("button",[15,50,100,80],"戦う",{name:'YES'});//OK枠
var btnCancel = win.add("button",[105,50,190,80],"逃げる",{name:'cancel'});//CANCEL枠


win.onShow =function(){ //.onShow：ウィンドウが表示される時に発生するイベント
    base();
    app.redraw();//画面表示を再描画
    //app.undo();//画面表示を再描画
} 


//逃げるボタンの処理ここから
btnCancel.onClick = function (){
    var lost = Math.floor (Math.random() * 3);
   // textLayer();//関数　レイヤーを作成
    if(lost === 1){
        battleMess('モンスターから逃げれた');//モンスターから逃げれた
        win.close(); //パネル外枠閉じる
    }else{
        battleMess ('モンスターから逃げられない');//モンスターから逃げられない
    };//else
    app.redraw();//画面表示を再描画
};  
//逃げるボタンの処理ここまで

//戦うボタンの処理ここから
btnOK.onClick = function(){

        //textLayer();　//関数　レイヤーを作成

         var  attack = Math.floor (Math.random() * 30) + 5;
        if(critical(attack)  === 45 ||critical(attack)  === 90){
            battleMess(myName + 'は、モンスターへクリティカル攻撃' + "  " + critical(attack));//クリティカル!!!!
        }else{
            battleMess(myName + 'は、モンスターへ' + "  " +critical(attack)　+ 'ダメージを与えた');
         };
         enemy = enemy - critical(attack);         
         if(enemy <= 0){
            $.sleep(500);

            battleMess('モンスターを倒した');//モンスターを倒した  
           blindfold();
            win.close(); //パネル外枠閉じる
        }else{
             $.sleep(2000);
             var  reAttack = Math.floor (Math.random() * 20) + 1;
             battleMess('モンスターから' + "  " + reAttack +'のダメージを受た');
             myLife = myLife - reAttack ;  
             statusMess(myLife)
            caveat();
            if(myLife <= 0){
            $.sleep(500);
            battleMess(myName + 'は気絶してしまった......');//モンスターに倒された  
            win.close(); //パネル外枠閉じる
            };
         };


    app.redraw();//画面表示を再描画
    //app.undo();//画面表示を再描画
};



//戦うボタンの処理ここまで

//ベース背景　ここから
function base(){

     //アートボード寸法計算　ここから
    var rect = actDoc.artboards[0].artboardRect;
    var left = rect[0];
    var top = rect[1];
    var right = rect[2];
    var bottom = rect [3];
 
    var width = (right - left) ;           //アートボードの横サイズ
    var height = (top - bottom) ;     //アートボードの縦サイズ
    //アートボード寸法計算　ここまで
    
    //背景色ここから
    var rectObj = actDoc.pathItems.rectangle(0,0,width,height);　//四角形作成
    rectObj.fillColor = setCMYKColor(0,0,0,100);//塗り　黒色
    rectObj.stroked = false;//線なし

    
    var baseLay = actDoc.layers['レイヤー 1'];//レイヤー１を指定
    baseLay.name = '背景画面';    //名称変更
    baseLay.locked = true; //レイヤーロック   
    //背景色ここまで
    
     //モンスターここから
    var monsterLay = actDoc.layers.add();//新規レイヤー作成
    monsterLay.name = 'モンスター';   //レイヤー名    
     
    var siza = 3
    for(i = 1 ; i<= 11 ; i++){
        for(j = 1 ; j<=15 ; j++){
            var rectObj = actDoc.pathItems.rectangle( zikuY(i),zikuX(j),siza,siza);　//四角形作成
            rectObj.fillColor = setCMYKColor(50,0,0,0);//塗り　黒色
            rectObj.stroked = false; 
            rectObj.note = 'y' + i + 'x' + j; 
        };
     };

    //不要　削除　ここから
    var todo = ['y1x1','y1x2','y1x3','y1x4','y1x5','y1x6','y1x7','y1x9','y1x10','y1x11','y1x12','y1x13','y1x14','y1x15',
                    'y2x1','y2x2','y2x3','y2x4','y2x5','y2x6','y2x10','y2x11','y2x12','y2x13','y2x14','y2x15',
                    'y3x1','y3x2','y3x3','y3x4','y3x5','y3x11','y3x12','y3x13','y3x14','y3x15',
                    'y4x1','y4x2','y4x3','y4x13','y4x14','y4x15',
                    'y5x1','y5x2','y5x14','y5x15',
                    'y6x1','y6x15',
                    'y7x6','y7x10',
                    'y9x1','y9x15',
                    'y10x1','y10x2','y10x14','y10x15',
                    'y11x1','y11x2','y11x3','y11x13','y11x14','y11x15',];
                    
    for(var i = 0; i<actDoc.pageItems.length; i++){
        for (var j = 0 ; j<todo.length ; j++){
                if(actDoc.pageItems[i].note === todo[j]){
                    try{
                        actDoc.pageItems[i].selected = true;
                    }catch(e){
                        alert ('選択でエラーが出ています。');
                    };//catch(e)
                };
            };
    };
    var selObj = actDoc.selection;
    for(var i = 0; i<selObj.length; i++){
            selObj[i].remove();
    };
    actDoc.selection = null;
    //不要　削除　ここまで

    //白色　ここから
    var white = ['y3x6','y3x7','y4x4','y4x5','y5x3','y5x4','y6x6','y7x5','y7x7','y8x6','y7x9','y6x10','y7x11','y8x10',];

    for(var i = 0; i<actDoc.pageItems.length; i++){
        for (var j = 0 ; j<white.length ; j++){
                if(actDoc.pageItems[i].note === white[j]){
                    try{
                        actDoc.pageItems[i].selected = true;
                    }catch(e){
                        alert ('選択でエラーが出ています。');
                    };//catch(e)
                };
        };
    };
    var selObj = actDoc.selection;
    for(var i = 0; i<selObj.length; i++){
            selObj[i].fillColor = setCMYKColor(0,0,0,0);
    };

    actDoc.selection = null;
    //白色　ここまで

    //オレンジ　ここから
    var orange = ['y9x5','y9x11','y10x6','y10x7','y10x8','y10x9','y10x10',];

    for(var i = 0; i<actDoc.pageItems.length; i++){
        for (var j = 0 ; j<orange.length ; j++){
                if(actDoc.pageItems[i].note === orange[j]){
                    try{
                        actDoc.pageItems[i].selected = true;
                    }catch(e){
                        alert ('選択でエラーが出ています。');
                    };//catch(e)
                };
        };
    };
    var selObj = actDoc.selection;
    for(var i = 0; i<selObj.length; i++){
        selObj[i].fillColor = setCMYKColor(0,60,55,0);
    };
    actDoc.selection = null;
    //オレンジ　ここまで

    //みずいろ　ここから
    var orange = ['y11x4','y11x5','y11x6','y11x7','y11x8','y11x9','y11x10','y11x11','y11x12',
                       'y10x4','y10x12','y10x13',
                       'y9x3','y9x6','y9x7','y9x8','y9x9','y9x14',
                       'y8x4','y8x7','y8x8','y8x9','y8x11','y8x14','y8x15',
                       'y7x3','y7x8','y7x12',
                       'y6x9','y6x11',
                       'y5x10',
                       'y4x10',
                       'y3x9',];

    for(var i = 0; i<actDoc.pageItems.length; i++){
        for (var j = 0 ; j<orange.length ; j++){
            if(actDoc.pageItems[i].note === orange[j]){
                try{
                    actDoc.pageItems[i].selected = true;
                }catch(e){
                    alert ('選択でエラーが出ています。');
                };//catch(e)
            };
        };
    };
    var selObj = actDoc.selection;
    for(var i = 0; i<selObj.length; i++){
        selObj[i].fillColor = setCMYKColor(55,20,0,0);
    };
    actDoc.selection = null;
    //みずいろ　ここから　ここまで

    //薄いみずいろ　ここから
    var orange = ['y2x8',
                       'y3x8',
                       'y4x6','y4x7', 'y4x8',
                       'y5x5','y5x6','y5x7',];

    for(var i = 0; i<actDoc.pageItems.length; i++){
        for (var j = 0 ; j<orange.length ; j++){
            if(actDoc.pageItems[i].note === orange[j]){
                try{
                    actDoc.pageItems[i].selected = true;
                }catch(e){
                    alert ('選択でエラーが出ています。');
                };//catch(e)
             };
        };
    };
    var selObj = actDoc.selection;
    for(var i = 0; i<selObj.length; i++){
        selObj[i].fillColor = setCMYKColor(20,0,0,0);
    };
    actDoc.selection = null;
    //薄いみずいろ　ここから　ここまで

    //紫　ここから
    var orange = ['y5x11','y5x12',
                       'y6x12','y6x13', 
                        'y7x13',
                       'y8x3','y8x12','y8 x13',
                       'y9x4','y9x10','y8 x12','y8x13',
                       'y10x5','y10x11',];

    for(var i = 0; i<actDoc.pageItems.length; i++){
        for (var j = 0 ; j<orange.length ; j++){
            if(actDoc.pageItems[i].note === orange[j]){
                try{
                    actDoc.pageItems[i].selected = true;
                }catch(e){
                    alert ('選択でエラーが出ています。');
                };//catch(e)
            };
        };
    };
    var selObj = actDoc.selection;
    for(var i = 0; i<selObj.length; i++){
        selObj[i].fillColor = setCMYKColor(20,0,0,0);
    };
    actDoc.selection = null;
    //紫　ここから　ここまで  
    //モンスター　ここまで
    
    //戦闘メッセージ枠　ここから
    var franeLay = actDoc.layers.add();//新規レイヤー作成
    franeLay.name = 'フレーム';   //レイヤー名
    
    var messLine =actDoc.pathItems.rectangle (-273.13, 158.5, 394.26 , 104.872);//四角形作成
    messLine.filled = false;//塗りなし
    messLine.stroked = true;//線あり
    messLine.strokeColor = setCMYKColor(0,0,0,0);//線　白色
    messLine.strokeWidth = 2.5;//線幅
    messLine.note = '枠'//テキストフレームに属性を追加
    //戦闘メッセージ枠　ここから
    
    //コマンド枠　ここから
    var statusLine = actDoc.pathItems.rectangle (-273.13, 42.5, 90.51, 104.872);
    statusLine.filled = false;//塗りなし
    statusLine.stroked = true;//線あり
    statusLine.strokeColor = setCMYKColor(0,0,0,0);//線　白色
    statusLine.strokeWidth = 2.5;//線幅       
    statusLine.note = '枠'//テキストフレームに属性を追加
    
    //コマンド枠　ここまで
    
    //ステータス　ここから
    var statusLay = actDoc.layers.add();//新規レイヤー作成
    statusLay.name = 'ステータス';   //レイヤー名
    
    var status = actDoc.textFrames.add();
    status.top = -283.13;
    status.left = 52.5;
    var statusText01= status.paragraphs.add('名前:' + myName );
    var statusText02= status.paragraphs.add('LV：12' );
    var status03 = actDoc.textFrames.add();
    status03.top = -325.74;
    status03.left = 52.5;
    var statusText03= status03.paragraphs.add( 'HP：'  + myLife);
    status03.note = 'HP';
   var status04 = actDoc.textFrames.add();
    status04.top = -346.92;
    status04.left = 52.5;
    var statusText04= status04.paragraphs.add( 'MP：0' );
    statusText01.fillColor = setCMYKColor(0,0,0,20);
    statusText02.fillColor = setCMYKColor(0,0,0,20);
    statusText03.fillColor = setCMYKColor(0,0,0,20);
    statusText04.fillColor = setCMYKColor(0,0,0,20);
    //ステータス　ここまで
    
    //戦闘文字レイヤーの作成ここから
    var layObj = actDoc.layers.add();//新規レイヤー作成
    layObj.name = '戦闘文字';   //レイヤー名

    var triangleObj = actDoc.textFrames.add();
    triangleObj.top = -362;
    triangleObj.left = 343.24;
    triangleObj.contents = '▼'
    triangleObj.paragraphs[0].size = 8;
    triangleObj.paragraphs[0].fillColor = setCMYKColor(0,0,0,0);//塗り　白色
    //戦闘文字レイヤーの作成ここまで

 


};
//ベース背景　ここまで



//CMYK設定　ここから
function setCMYKColor(c,m,y,k){
    var CMYK = new CMYKColor();//CMYKの初期化
    CMYK.cyan = c;
    CMYK.magenta = m;
    CMYK.yellow = y;
    CMYK.black = k;
    return CMYK
 }
//CMYK設定　ここまで

//モンスター座標　ここから
function zikuY(y){
    var ziku = -135.664;
    var yziku = ziku - (3 * y);
    return yziku
    };

function zikuX(x){
    var ziku = 241.948;
    var xziku = ziku +  (3 * x);
    return xziku
    };    
//モンスター座標　ここから

//警告　ここから
function caveat(){
   if(myLife > red && myLife <= yellow){//20より大きく　かつ　50以下

        for(var i = 0; i<actDoc.layers['フレーム'].pageItems.length; i++){
            if(actDoc.layers['フレーム'].pageItems[i].note === '枠'){
                try{
                    actDoc.layers['フレーム'].pageItems[i].selected = true;
                }catch(e){
                    alert ('ライン選択でエラーが出ています。');
                };//catch(e)
             };//if
        };//for
       var selObj = actDoc.selection;
       for(var i = 0; i<selObj.length; i++){
            selObj[i].strokeColor = setCMYKColor(0,0,50,0);//線　黄色
        };
        app.executeMenuCommand("deselectall");//選択解除
        var actLay02 = actDoc.layers['ステータス'];
        actLay02.locked = false; //レイヤーロック解除
        for(var i=0; i<actDoc.textFrames.length; i++){　
            try{
                    actDoc.textFrames[i].selected = true;　//あれば選択
            }catch(e){};
        };
        var selObj = actDoc.selection;
       for(var i = 0; i<selObj.length; i++){
            for(var j = 0; j < selObj[i].paragraphs.length; j++){
                selObj[i].paragraphs[j].fillColor = setCMYKColor(0,0,50,0);
            };
        };
    }else{
        if(myLife >= 0 && myLife <= yellow){//0以上かつ30以下
            for(var i = 0; i<actDoc.layers['フレーム'].pageItems.length; i++){
                if(actDoc.layers['フレーム'].pageItems[i].note === '枠'){
                    try{
                        actDoc.layers['フレーム'].pageItems[i].selected = true;
                    }catch(e){
                        alert ('ライン選択でエラーが出ています。');
                    };
                };
            };
            var selObj = actDoc.selection;
            for(var i = 0; i<selObj.length; i++){
                selObj[i].strokeColor = setCMYKColor(0,50,0,0);//線　赤色
            };
            app.executeMenuCommand("deselectall");//選択解除
            for(var i=0; i<actDoc.textFrames.length; i++){　
                try{
                    actDoc.textFrames[i].selected = true;　//あれば選択
                }catch(e){};
            };
            var selObj = actDoc.selection;
            for(var i = 0; i<selObj.length; i++){
                for(var j = 0; j < selObj[i].paragraphs.length; j++){
                    selObj[i].paragraphs[j].fillColor = setCMYKColor(0,50,0,0);
                };//for
            };//for
        };//if
    };//else
    app.executeMenuCommand("deselectall");//選択解除
};
//警告　ここまで

//ステータス値の変化ここから
function statusMess(aaa){
        if(0 >= myLife){
            myLife = 0;
         };
         for(var i=0; i<actDoc.layers['ステータス'].textFrames.length; i++){　
             if(actDoc.layers['ステータス'].textFrames[i].note === 'HP'){
            actDoc.layers['ステータス'].textFrames[i].selected = true;　//あれば選択
            };
          };
          var selObj = actDoc.selection;　//ドキュメント内の選択中のオブジェクト
          for(var j=0; j<selObj.length; j++){     
            selObj[j].paragraphs[0].remove();//3段目の文字を削除    
            selObj[j].paragraphs.addBefore('HP：'  + myLife);
          };
}
//ステータス値の変化ここまで

//戦闘文字の作成ここから
function battleMess(text){

    try{//戦闘文字のテキストフレームが存在する場合 
        if(actDoc.layers['戦闘文字'].textFrames.length === 2){//戦闘文字レイヤー内のテキストフレームを数える
            for(var i=0; i<actDoc.textFrames.length; i++){　
                if(actDoc.textFrames[i].note === '戦闘メッセージ'){   //属性に【戦闘メッセージ】があるか確認
                    actDoc.textFrames[i].selected = true;　//あれば選択
                };
            };
            try{
                var selObj = actDoc.selection;　//ドキュメント内の選択中のオブジェクト
                for(var j=0; j<selObj.length; j++){            
                    selObj[j].paragraphs.addBefore (text);//テキストを段落前に追加
                    selObj[j].paragraphs[5].remove();//６段目の文字を削除
                };
            }catch(e){};
        }else{//戦闘文字のテキストフレームが存在しない場合 
            var messArea = actDoc.pathItems.rectangle(-287.3,172.67,366.26,76.872);//四角形を作成
            var txtObj = actDoc.textFrames.areaText(messArea);//四角形をエリアテキストに変換
            txtObj.note = '戦闘メッセージ'//テキストフレームに属性を追加
            var prObj = txtObj.paragraphs.add(text);　//文字を入力
            txtObj.paragraphs[0].fillColor = setCMYKColor(0,0,0,0);　//段落の文字色
            txtObj.paragraphs[0].autoLeading = false;　//段落の行間を指定する
            txtObj.paragraphs[0].leading = 16;//行間を16ｐｔにセット
           txtObj.paragraphs[0].size = 11;
        };
    } catch(e){//エラーの場合
        alert ( 'メッセージでエラーが起きています');
    };
    app.executeMenuCommand("deselectall");//選択解除
};
//戦闘文字の作成ここまで

function blindfold(){
    var layObj = app.activeDocument.layers['モンスター'];
    app.activeDocument.activeLayer = layObj;
    layObj.visible = false;
}


//クリティカル攻撃　ここから
function critical(text){
    if(text % 3 === 0 && text % 5 === 0){
        return (text * 3);//クリティカル
    }else{
        return text;
    };
};
//クリティカル攻撃　ここから
//win.center();//センター表示
win.show();　//ウインドウパネルの表示

